import {EntityRepository, Repository} from "typeorm";
import { AboutPageOpenSourceCommunitySectionCmsEntity } from "./entities/about-page-open-source-community-section-cms.entity";
import { UpdateAboutPageOpenSourceCommunitySectionCmsDto } from "./dto/update-about-page-open-source-community-section-cms.dto";

@EntityRepository(AboutPageOpenSourceCommunitySectionCmsEntity)
export class AboutPageOpenSourceCommunitySectionCmsRepository extends Repository<AboutPageOpenSourceCommunitySectionCmsEntity> {

    async createEntity(dto: UpdateAboutPageOpenSourceCommunitySectionCmsDto): Promise<AboutPageOpenSourceCommunitySectionCmsEntity | Error> {
        try {
            const entity = this.create({
                title: dto.title,
                description: dto.description,
                heading: dto.heading,
                image: dto.image
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateAboutPageOpenSourceCommunitySectionCmsDto, id: string): Promise<AboutPageOpenSourceCommunitySectionCmsEntity | Error> {
        try {
            await this.update(id, {
                title: dto.title,
                description: dto.description,
                heading: dto.heading,
                image: dto.image
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<AboutPageOpenSourceCommunitySectionCmsEntity[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}