import {EntityRepository, Repository} from "typeorm";
import { AboutPageOurCommunitySectionCmsEntity } from "./entities/about-page-our-community-section-cms.entity";
import { UpdateAboutPageOurCommunitySectionCmsDto } from "./dto/update-about-page-our-community-section-cms.dto";

@EntityRepository(AboutPageOurCommunitySectionCmsEntity)
export class AboutPageOurCommunitySectionCmsRepository extends Repository<AboutPageOurCommunitySectionCmsEntity> {

    async createEntity(dto: UpdateAboutPageOurCommunitySectionCmsDto): Promise<AboutPageOurCommunitySectionCmsEntity | Error> {
        try {
            const entity = this.create({
                title: dto.title,
                description: dto.description,
                heading: dto.heading,
                image: dto.image
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateAboutPageOurCommunitySectionCmsDto, id: string): Promise<AboutPageOurCommunitySectionCmsEntity | Error> {
        try {
            await this.update(id, {
                title: dto.title,
                description: dto.description,
                heading: dto.heading,
                image: dto.image
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<AboutPageOurCommunitySectionCmsEntity[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}