import { EntityRepository, Repository } from "typeorm";
import { HomePageInstagramSectionCmsEntity } from "./entities/home-page-instagram-section-cms.entity";
import { UpdateHomePageInstagramSectionCmsDto } from "./dto/update-home-page-instagram-section-cms.dto";

@EntityRepository(HomePageInstagramSectionCmsEntity)
export class HomePageInstagramSectionCmsRepository extends Repository<HomePageInstagramSectionCmsEntity> {

    async createEntity(dto: UpdateHomePageInstagramSectionCmsDto): Promise<HomePageInstagramSectionCmsEntity | Error> {
        try {
            const entity = this.create({
                heading: dto.heading,
                title: dto.title
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateHomePageInstagramSectionCmsDto, id: string): Promise<HomePageInstagramSectionCmsEntity | Error> {
        try {
            await this.update(id, {
                heading: dto.heading,
                title: dto.title
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<HomePageInstagramSectionCmsEntity[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}