import { EntityRepository, Repository } from "typeorm";
import { LoginPageCmsEntity } from "./entities/login-page-cms.entity";
import { UpdateLoginPageCmsDto } from "./dto/update-login-page-cms.dto";

@EntityRepository(LoginPageCmsEntity)
export class LoginPageCmsRepository extends Repository<LoginPageCmsEntity> {

    async createEntity(dto: UpdateLoginPageCmsDto): Promise<LoginPageCmsEntity | Error> {
        try {
            const entity = this.create({
                title: dto.title,
                buttonText: dto.buttonText,
                image: dto.image
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateLoginPageCmsDto, id: string): Promise<LoginPageCmsEntity | Error> {
        try {
            await this.update(id, {
                title: dto.title,
                buttonText: dto.buttonText,
                image: dto.image
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<LoginPageCmsEntity[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}