import { EntityRepository, Repository } from "typeorm";
import { UpdatePageTitleCmsDto } from "./dto/update-page-title-cms.dto";
import { PageTitleCms } from "./entities/page-title-cms.entity";

@EntityRepository(PageTitleCms)
export class PageTitleCmsRepository extends Repository<PageTitleCms> {

    async createEntity(dto: UpdatePageTitleCmsDto): Promise<PageTitleCms | Error> {
        try {
            const entity = this.create({
                homePageTitle: dto.homePageTitle,
                shopPageTitle: dto.shopPageTitle,
                blogPageTitle: dto.blogPageTitle,
                aboutPageTitle: dto.aboutPageTitle,
                helpAndSupportPageTitle: dto.helpAndSupportPageTitle,
                accountPageTitle: dto.accountPageTitle,
                faqPageTitle: dto.faqPageTitle,
                privacyPageTitle: dto.privacyPageTitle,
                termsPageTitle: dto.termsPageTitle,
                cartPageTitle: dto.cartPageTitle,
                wishlistPageTitle: dto.wishlistPageTitle,
                checkoutPageTitle: dto.checkoutPageTitle,
                dashboardPageTitle: dto.dashboardPageTitle,
                orderHistoryPageTitle: dto.orderHistoryPageTitle,
                transactionsPageTitle: dto.transactionsPageTitle,
                addressPageTitle: dto.addressPageTitle,
                taxExemptPageTitle: dto.taxExemptPageTitle,
                resetPassPageTitle: dto.resetPassPageTitle,
                registerPageTitle: dto.registerPageTitle,
                loginPageTitle: dto.loginPageTitle,
                forgetPassPageTitle: dto.forgetPassPageTitle,
                changePassPageTitle: dto.changePassPageTitle,
                confirmOrderPageTitle: dto.confirmOrderPageTitle
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async UpdateEntity(dto: UpdatePageTitleCmsDto, id: string): Promise<PageTitleCms | Error> {
        try {
            await this.update(id, {
                homePageTitle: dto.homePageTitle,
                shopPageTitle: dto.shopPageTitle,
                blogPageTitle: dto.blogPageTitle,
                aboutPageTitle: dto.aboutPageTitle,
                helpAndSupportPageTitle: dto.helpAndSupportPageTitle,
                accountPageTitle: dto.accountPageTitle,
                faqPageTitle: dto.faqPageTitle,
                privacyPageTitle: dto.privacyPageTitle,
                termsPageTitle: dto.termsPageTitle,
                cartPageTitle: dto.cartPageTitle,
                wishlistPageTitle: dto.wishlistPageTitle,
                checkoutPageTitle: dto.checkoutPageTitle,
                dashboardPageTitle: dto.dashboardPageTitle,
                orderHistoryPageTitle: dto.orderHistoryPageTitle,
                transactionsPageTitle: dto.transactionsPageTitle,
                addressPageTitle: dto.addressPageTitle,
                taxExemptPageTitle: dto.taxExemptPageTitle,
                resetPassPageTitle: dto.resetPassPageTitle,
                registerPageTitle: dto.registerPageTitle,
                loginPageTitle: dto.loginPageTitle,
                forgetPassPageTitle: dto.forgetPassPageTitle,
                changePassPageTitle: dto.changePassPageTitle,
                confirmOrderPageTitle: dto.confirmOrderPageTitle
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<PageTitleCms[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}