import { Module } from '@nestjs/common';
import { TypeOrmModule } from '@nestjs/typeorm';
import { ProductStockImportController } from './product-stock-import.controller';
import { ProductStockImportRepository } from './product-stock-import.repository';
import { ProductStockImportService } from './product-stock-import.service';
import { FileUploadsService } from 'src/modules/file-uploads/file-uploads.service';

@Module({
    imports: [
        TypeOrmModule.forFeature([ProductStockImportRepository])
    ],
    controllers: [ProductStockImportController],
    providers: [ProductStockImportService, FileUploadsService]
})
export class ProductStockImportModule {}
